package com.mdp.voice;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Toolkit;

import javax.swing.JFrame;

import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyListener;

import java.awt.event.KeyEvent;
import java.net.PasswordAuthentication;

import javax.swing.BorderFactory;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JPasswordField;
import javax.swing.JButton;

import javax.swing.JOptionPane;


	public class Status extends JFrame implements ActionListener, KeyListener  {

		private JPanel headerPane;
		private JPanel contentPane;	
		private JPanel footerPane;	
		
		private JLabel lStatusIn = new JLabel( "" );
		private JLabel lStatusOut = new JLabel( "" );
		private JLabel lStatusElapsed = new JLabel( "" );
		
		private JTextField tConnect = new JTextField();		
	
		private JButton bEnd = new JButton("End this call!");	
	
		private Globals globals;
		
		/**
		 * Called when SOCKS requires auth
		 * @param a
		 */
		
		public void showIt( Globals globals  ) {
			this.globals = globals;
			this.globals.setStatusScreen( this );
			
			this.setSize( new Dimension( 300, 200 ) );
			Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
			//this.setDefaultCloseOperation(EXIT_ON_CLOSE);
			
			setLocation((screenSize.width - 300 ) / 2, // and centered
					(screenSize.height - 200 ) / 2);
			
			
			headerPane = new JPanel();
			headerPane.setBackground( Color.white );
			
			JLabel sLabel = new JLabel( "Java Voice - Call in progress...!" );
	        sLabel.setFont(new Font("SansSerif", Font.BOLD, 18 ));
	        
			headerPane.setLayout( new FlowLayout( FlowLayout.LEFT ));
	        headerPane.add( sLabel );
	                
	        headerPane.setBorder( BorderFactory.createEtchedBorder() );        
			
	        contentPane = new JPanel();
	        contentPane.setBorder(BorderFactory.createEtchedBorder());        
	        
	        contentPane.setLayout( null );
       
	        contentPane.add( lStatusIn );
	        contentPane.add( lStatusOut );
	        contentPane.add( lStatusElapsed );	        
	        
	        lStatusIn.setBounds( 10, 10, 300, 15 );        
	        lStatusOut.setBounds( 10, 25, 300, 15 );	        
	        lStatusElapsed.setBounds( 10, 40, 300, 15 );
	        
			footerPane = new JPanel();
			footerPane.setBorder(BorderFactory.createEtchedBorder());
			
			footerPane.add( bEnd );
			
	        bEnd.addActionListener( this );
        
       

	        getContentPane().setLayout(new BorderLayout());        
			getContentPane().add( headerPane, BorderLayout.NORTH );
			getContentPane().add( contentPane, BorderLayout.CENTER );		
			getContentPane().add( footerPane, BorderLayout.SOUTH );		

		
			setVisible( true );

		}
		
		
		/**
		 * Method fired on an action event (Button click etc.)
		 */
		public synchronized void actionPerformed(ActionEvent e) {
	    	try {
	    		
	    		if ( e.getSource() == bEnd ) {
	    			globals.setHangup( true );
	    			this.dispose();
	    		}
	            
	        } catch (Exception ex ) {
	        	  Util.logger( ex.toString() );
	           }

	    }
		
		/**
		 * Set status message
		 * @param s
		 */
		public void setStatusIn( String s ) {
			lStatusIn.setText( s );
		}

		public void setStatusOut( String s ) {
			lStatusOut.setText( s );
		}

		public void setStatusElapsed( String s ) {
			lStatusElapsed.setText( s );
		}

		 /** Handle the key typed event from the text field. */
	    public void keyTyped(KeyEvent e) {
	    	
	    	
	    }

	    /** Handle the key-pressed event from the text field. */
	    public void keyPressed(KeyEvent e) {
	    	//Alert.show( "KP"  +  e.getID() );
	    }

	    /** Handle the key-released event from the text field. */
	    public void keyReleased(KeyEvent e) {
	    	//Alert.show( "KR"  +  e.getID() );	
	    }
		
	    
	    public synchronized String getTarget() {
	    	try {
	    		wait();
	    		
	    	} catch ( Exception e ) {
	    		
	    	}	    	
	    	return tConnect.getText();
	    }

	}

